Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ActionRegistry.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -1,4 +1,4 @@
 /*
- * ActionRegistry.cpp
+ * Registry<Action>.cpp
  *
  *  Created on: Jan 7, 2010
@@ -6,121 +6,43 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/ActionRegistry.hpp"
-#include "Actions/Action.hpp"
-
 #include "Patterns/Singleton_impl.hpp"
-
-#include <string>
-#include "Helpers/Assert.hpp"
-#include <iostream>
-
-using namespace std;
+#include "Patterns/Registry_impl.hpp"
 
 /** Constructor for class ActionRegistry.
  */
 ActionRegistry::ActionRegistry()
-{
-}
+{}
 
 /** Destructor for class ActionRegistry.
  */
 ActionRegistry::~ActionRegistry()
+{}
+
+/** Just passes on call to Registry<Action>::getByName().
+ * \param name name of Action
+ * \return pointer to Action
+ */
+Action* ActionRegistry::getActionByName(const std::string name)
 {
-  map<const string,Action*>::iterator iter;
-  for(iter=actionMap.begin();iter!=actionMap.end();++iter) {
-    delete iter->second;
-  }
-  actionMap.clear();
+  return getByName(name);
 }
 
-/** Returns pointer to an action named by \a name.
- * \param name name of action
- * \return pointer to Action
+/** Just passes on call to Registry<Action>::isPresentByName().
+ * \param name name of Action
+ * \return true - Action instance present, false - not
  */
-Action* ActionRegistry::getActionByName(const std::string name){
-  map<const string,Action*>::iterator iter;
-  iter = actionMap.find(name);
-  ASSERT(iter!=actionMap.end(),"Query for an action not stored in registry");
-  return iter->second;
+bool ActionRegistry::isActionPresentByName(const std::string name)
+{
+  return isPresentByName(name);
 }
 
-/** States whether action is present or not.
- * \note This iss needed as ActionRegistry::getActionByName() ASSERT()s that action is in map.
- * \param name name of action
- * \return true - Action present, false - Action absent
- */
-bool ActionRegistry::isActionByNamePresent(const std::string name){
-  map<const string,Action*>::iterator iter;
-  iter = actionMap.find(name);
-  return iter!=actionMap.end();
-}
-
-/** Registers an Action with the ActionRegistry.
- * \param *action pointer to Action.
- */
-void ActionRegistry::registerAction(Action* action){
-  pair<map<const string,Action*>::iterator,bool> ret;
-  //cout << "Trying to register action with name " << action->getName() << "." << endl;
-  ret = actionMap.insert(pair<const string,Action*>(action->getName(),action));
-  ASSERT(ret.second,"Two actions with the same name added to registry");
-}
-
-/** Unregisters an Action.
- * \param *action pointer to Action.
- */
-void ActionRegistry::unregisterAction(Action* action){
-  //cout << "Unregistering action with name " << action->getName() << "." << endl;
-  actionMap.erase(action->getName());
-}
-
-/** Returns an iterator pointing to the start of the map of Action's.
- * \return begin iterator
- */
-std::map<const std::string,Action*>::iterator ActionRegistry::getBeginIter()
-{
-  return actionMap.begin();
-}
-
-/** Returns an iterator pointing to the end of the map of Action's.
- * \return end iterator
- */
-std::map<const std::string,Action*>::iterator ActionRegistry::getEndIter()
-{
-  return actionMap.end();
-}
-
-/** Returns a const iterator pointing to the start of the map of Action's.
- * \return constant begin iterator
- */
-std::map<const std::string,Action*>::const_iterator ActionRegistry::getBeginIter() const
-{
-  return actionMap.begin();
-}
-
-/** Returns a const iterator pointing to the end of the map of Action's.
- * \return constant end iterator
- */
-std::map<const std::string,Action*>::const_iterator ActionRegistry::getEndIter() const
-{
-  return actionMap.end();
-}
-
-/** Prints the contents of the ActionRegistry \a &m to \a &ost.
- * \param &ost output stream
- * \param &m reference to ActionRegistry
- * \return reference to the above out stream for concatenation
- */
-ostream& operator<<(ostream& ost, const ActionRegistry& m)
-{
-  ost << "ActionRegistry contains:" << endl;
-  for (std::map<const std::string,Action*>::const_iterator iter = m.getBeginIter(); iter != m.getEndIter(); ++iter) {
-    ost << "\t" << iter->first << " with pointer " << iter->second << endl;
-  }
-  return ost;
-};
-
-
-
 CONSTRUCT_SINGLETON(ActionRegistry)
+CONSTRUCT_REGISTRY(Action)
Index: src/Actions/ActionRegistry.hpp
===================================================================
--- src/Actions/ActionRegistry.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ActionRegistry.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -1,4 +1,4 @@
 /*
- * ActionRegistry.hpp
+ * Registry<Action>.hpp
  *
  *  Created on: Jan 7, 2010
@@ -9,35 +9,31 @@
 #define ACTIONREGISTRY_HPP_
 
-#include <iostream>
+#include <iosfwd>
 #include <string>
 #include <map>
 
+#include "Patterns/Registry.hpp"
 #include "Patterns/Singleton.hpp"
+#include "Actions/Action.hpp"
 
-class Action;
-
-class ActionRegistry : public Singleton<ActionRegistry>
+/** Action Registry.
+ *
+ * The Action registry is a storage for any Action instance to retrieved by name.
+ * It is a singleton and can be called from anywhere.
+ *
+ */
+class ActionRegistry : public Singleton<ActionRegistry>, public Registry<Action>
 {
   friend class Singleton<ActionRegistry>;
+  //friend class Registry<Action>;
+
 public:
-  Action* getActionByName(const std::string);
-  bool isActionByNamePresent(const std::string name);
-  void registerAction(Action*);
-  void unregisterAction(Action*);
-
-  std::map<const std::string,Action*>::iterator getBeginIter();
-  std::map<const std::string,Action*>::const_iterator getBeginIter() const;
-  std::map<const std::string,Action*>::iterator getEndIter();
-  std::map<const std::string,Action*>::const_iterator getEndIter() const;
-
-private:
-  std::map<const std::string,Action*> actionMap;
+  Action* getActionByName(const std::string name);
+  bool isActionPresentByName(const std::string name);
 
 private:
   ActionRegistry();
-  virtual ~ActionRegistry();
+  ~ActionRegistry();
 };
 
-std::ostream& operator<<(std::ostream& ost, const ActionRegistry& m);
-
 #endif /* ACTIONREGISTRY_HPP_ */
Index: src/Actions/ActionSequence.cpp
===================================================================
--- src/Actions/ActionSequence.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ActionSequence.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/ActionSequence.hpp"
 #include "Actions/Action.hpp"
+#include "UIElements/Dialog.hpp"
 
 #include "Helpers/Assert.hpp"
@@ -36,4 +42,13 @@
     return theAction;
   }
+}
+
+// this method is used outside the ActionModule
+// Each action registers itself with the history
+Dialog* ActionSequence::fillAllDialogs(Dialog *dialog){
+  for(actionSet::iterator it=actions.begin(); it!=actions.end(); it++){
+    dialog = (*it)->fillDialog(dialog);
+  }
+  return dialog;
 }
 
Index: src/Actions/ActionSequence.hpp
===================================================================
--- src/Actions/ActionSequence.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ActionSequence.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -36,4 +36,5 @@
 protected:
   stateSet callAll(bool); // Dummy parameter to allow overloading
+  Dialog* fillAllDialogs(Dialog *dialog);
   stateSet undoAll(stateSet);
   stateSet redoAll(stateSet);
Index: src/Actions/AnalysisAction/MolecularVolumeAction.cpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,13 +6,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AnalysisAction/MolecularVolumeAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "boundary.hpp"
 #include "config.hpp"
 #include "molecule.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "tesselation.hpp"
 #include "World.hpp"
 
@@ -24,5 +31,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char AnalysisMolecularVolumeAction::NAME[] = "molecular-volume";
@@ -35,11 +42,23 @@
 {}
 
+void AnalysisMolecularVolume() {
+  ActionRegistry::getInstance().getActionByName(AnalysisMolecularVolumeAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog * AnalysisMolecularVolumeAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr AnalysisMolecularVolumeAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
-  molecule *mol = NULL;
+  int molID = -1;
+  // obtain information
+  ValueStorage::getInstance().queryCurrentValue(NAME, molID);
 
-  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
-
-  if(dialog->display()) {
+  // execute action
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    molecule *mol = iter->second;
     class Tesselation *TesselStruct = NULL;
     const LinkedCell *LCList = NULL;
@@ -47,5 +66,5 @@
     LCList = new LinkedCell(mol, 10.);
     config * const configuration = World::getInstance().getConfig();
-    Boundaries *BoundaryPoints = NULL;
+    //Boundaries *BoundaryPoints = NULL;
     //FindConvexBorder(mol, BoundaryPoints, TesselStruct, LCList, argv[argptr]);
     FindNonConvexBorder(mol, TesselStruct, LCList, 5., NULL);
@@ -57,32 +76,22 @@
     delete(TesselStruct);
     delete(LCList);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
   }
+  return Action::success;
 }
 
 Action::state_ptr AnalysisMolecularVolumeAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
-
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  return Action::success;
 }
 
 Action::state_ptr AnalysisMolecularVolumeAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return Action::success;
 }
 
 bool AnalysisMolecularVolumeAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AnalysisMolecularVolumeAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/AnalysisAction/MolecularVolumeAction.hpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -9,7 +9,15 @@
 #define MOLECULARVOLUMEACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Actions/Action.hpp"
 
+void AnalysisMolecularVolume();
+
 class AnalysisMolecularVolumeAction : public Action {
+  friend void AnalysisMolecularVolume();
 public:
   AnalysisMolecularVolumeAction();
@@ -20,4 +28,7 @@
 
   virtual const std::string getName();
+
+protected:
+  virtual Dialog * fillDialog(Dialog*);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,15 +6,22 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AnalysisAction/PairCorrelationAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "analysis_correlation.hpp"
 #include "boundary.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
@@ -26,5 +33,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char AnalysisPairCorrelationAction::NAME[] = "pair-correlation";
@@ -37,11 +44,35 @@
 {}
 
+void AnalysisPairCorrelation(std::vector< element *> &elements, double BinStart, double BinWidth, double BinEnd, string &outputname, string &binoutputname, bool periodic) {
+  ValueStorage::getInstance().setCurrentValue("elements", elements);
+  ValueStorage::getInstance().setCurrentValue("bin-start", BinStart);
+  ValueStorage::getInstance().setCurrentValue("bin-width", BinWidth);
+  ValueStorage::getInstance().setCurrentValue("bin-end", BinEnd);
+  ValueStorage::getInstance().setCurrentValue("output-file", outputname);
+  ValueStorage::getInstance().setCurrentValue("bin-output-file", binoutputname);
+  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
+  ActionRegistry::getInstance().getActionByName(AnalysisPairCorrelationAction::NAME)->call(Action::NonInteractive);
+};
+
+
+Dialog* AnalysisPairCorrelationAction::fillDialog(Dialog* dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryElements("elements", ValueStorage::getInstance().getDescription("elements"));
+  dialog->queryDouble("bin-start", ValueStorage::getInstance().getDescription("bin-start"));
+  dialog->queryDouble("bin-width", ValueStorage::getInstance().getDescription("bin-width"));
+  dialog->queryDouble("bin-end", ValueStorage::getInstance().getDescription("bin-end"));
+  dialog->queryString("output-file", ValueStorage::getInstance().getDescription("output-file"));
+  dialog->queryString("bin-output-file", ValueStorage::getInstance().getDescription("bin-output-file"));
+  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
+
+  return dialog;
+}
+
 Action::state_ptr AnalysisPairCorrelationAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   int ranges[3] = {1, 1, 1};
   double BinEnd = 0.;
   double BinStart = 0.;
   double BinWidth = 0.;
-  molecule *Boundary = NULL;
   string outputname;
   string binoutputname;
@@ -49,141 +80,51 @@
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
+  std::vector<const element *> elements;
   string type;
   Vector Point;
   BinPairMap *binmap = NULL;
-  MoleculeListClass *molecules = World::getInstance().getMolecules();
 
-  // first dialog: Obtain which type of correlation
-  dialog->queryString(NAME, &type, MapOfActions::getInstance().getDescription(NAME));
-  if(dialog->display()) {
-    delete dialog;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  // obtain information
+  ValueStorage::getInstance().queryCurrentValue("elements", elements);
+  ValueStorage::getInstance().queryCurrentValue("bin-start", BinStart);
+  ValueStorage::getInstance().queryCurrentValue("bin-width", BinWidth);
+  ValueStorage::getInstance().queryCurrentValue("bin-end", BinEnd);
+  ValueStorage::getInstance().queryCurrentValue("output-file", outputname);
+  ValueStorage::getInstance().queryCurrentValue("bin-output-file", binoutputname);
+  ValueStorage::getInstance().queryCurrentValue("periodic", periodic);
 
-  // second dialog: Obtain parameters specific to this type
-  dialog = UIFactory::getInstance().makeDialog();
-  if (type == "P")
-    dialog->queryVector("position", &Point, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription("position"));
-  if (type == "S")
-    dialog->queryMolecule("molecule-by-id", &Boundary, MapOfActions::getInstance().getDescription("molecule-by-id"));
-  dialog->queryElement("elements", &elements, MapOfActions::getInstance().getDescription("elements"));
-  dialog->queryDouble("bin-start", &BinStart, MapOfActions::getInstance().getDescription("bin-start"));
-  dialog->queryDouble("bin-width", &BinWidth, MapOfActions::getInstance().getDescription("bin-width"));
-  dialog->queryDouble("bin-end", &BinEnd, MapOfActions::getInstance().getDescription("bin-end"));
-  dialog->queryString("output-file", &outputname, MapOfActions::getInstance().getDescription("output-file"));
-  dialog->queryString("bin-output-file", &binoutputname, MapOfActions::getInstance().getDescription("bin-output-file"));
-  dialog->queryBoolean("periodic", &periodic, MapOfActions::getInstance().getDescription("periodic"));
-
-  if(dialog->display()) {
-    output.open(outputname.c_str());
-    binoutput.open(binoutputname.c_str());
-    if (type == "E") {
-      PairCorrelationMap *correlationmap = NULL;
-      if (periodic)
-        correlationmap = PeriodicPairCorrelation(World::getInstance().getMolecules(), elements, ranges);
-      else
-        correlationmap = PairCorrelation(World::getInstance().getMolecules(), elements);
-      OutputPairCorrelation(&output, correlationmap);
-      binmap = BinData( correlationmap, BinWidth, BinStart, BinEnd );
-      OutputCorrelation ( &binoutput, binmap );
-      delete(binmap);
-      delete(correlationmap);
-    } else if (type == "P")  {
-      cout << "Point to correlate to is  " << Point << endl;
-      CorrelationToPointMap *correlationmap = NULL;
-      if (periodic)
-        correlationmap  = PeriodicCorrelationToPoint(molecules, elements, &Point, ranges);
-      else
-        correlationmap = CorrelationToPoint(molecules, elements, &Point);
-      OutputCorrelationToPoint(&output, correlationmap);
-      binmap = BinData( correlationmap, BinWidth, BinStart, BinEnd );
-      OutputCorrelation ( &binoutput, binmap );
-      delete(binmap);
-      delete(correlationmap);
-    } else if (type == "S") {
-      ASSERT(Boundary != NULL, "No molecule specified for SurfaceCorrelation.");
-      const double radius = 4.;
-      double LCWidth = 20.;
-      if (BinEnd > 0) {
-        if (BinEnd > 2.*radius)
-          LCWidth = BinEnd;
-        else
-          LCWidth = 2.*radius;
-      }
-
-      // get the boundary
-      class Tesselation *TesselStruct = NULL;
-      const LinkedCell *LCList = NULL;
-      // find biggest molecule
-      int counter  = molecules->ListOfMolecules.size();
-      bool *Actives = new bool[counter];
-      counter = 0;
-      for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-        Actives[counter++] = (*BigFinder)->ActiveFlag;
-        (*BigFinder)->ActiveFlag = (*BigFinder == Boundary) ? false : true;
-      }
-      LCList = new LinkedCell(Boundary, LCWidth);
-      FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
-      CorrelationToSurfaceMap *surfacemap = NULL;
-      if (periodic)
-        surfacemap = PeriodicCorrelationToSurface( molecules, elements, TesselStruct, LCList, ranges);
-      else
-        surfacemap = CorrelationToSurface( molecules, elements, TesselStruct, LCList);
-      delete LCList;
-      OutputCorrelationToSurface(&output, surfacemap);
-      // re-set ActiveFlag
-      counter = 0;
-      for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-        (*BigFinder)->ActiveFlag = Actives[counter++];
-      }
-      delete[] Actives;
-      // check whether radius was appropriate
-      {
-        double start; double end;
-        GetMinMax( surfacemap, start, end);
-        if (LCWidth < end)
-          DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell width is smaller than the found range of values! Bins can only be correct up to: " << radius << "." << endl);
-      }
-      binmap = BinData( surfacemap, BinWidth, BinStart, BinEnd );
-      OutputCorrelation ( &binoutput, binmap );
-      delete TesselStruct;  // surfacemap contains refs to triangles! delete here, not earlier!
-      delete(binmap);
-      delete(surfacemap);
-    } else {
-      return Action::failure;
-    }
-    output.close();
-    binoutput.close();
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  // execute action
+  output.open(outputname.c_str());
+  binoutput.open(binoutputname.c_str());
+  PairCorrelationMap *correlationmap = NULL;
+  std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
+  if (periodic)
+    correlationmap = PeriodicPairCorrelation(molecules, elements, ranges);
+  else
+    correlationmap = PairCorrelation(molecules, elements);
+  OutputPairCorrelation(&output, correlationmap);
+  binmap = BinData( correlationmap, BinWidth, BinStart, BinEnd );
+  OutputCorrelation ( &binoutput, binmap );
+  delete(binmap);
+  delete(correlationmap);
+  output.close();
+  binoutput.close();
+  return Action::success;
 }
 
 Action::state_ptr AnalysisPairCorrelationAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
-
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  return Action::success;
 }
 
 Action::state_ptr AnalysisPairCorrelationAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  return Action::success;
 }
 
 bool AnalysisPairCorrelationAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AnalysisPairCorrelationAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/AnalysisAction/PairCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -9,7 +9,19 @@
 #define PAIRCORRELATIONACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Actions/Action.hpp"
+#include <string>
+#include <vector>
+
+class element;
+
+void AnalysisPairCorrelation(std::vector< element *> &elements, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
 
 class AnalysisPairCorrelationAction : public Action {
+  friend void AnalysisPairCorrelation(std::vector< element *> &elements, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
 public:
   AnalysisPairCorrelationAction();
@@ -20,6 +32,8 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog*);
 private:
-  virtual Action::state_ptr performCall();
+   virtual Action::state_ptr performCall();
   virtual Action::state_ptr performUndo(Action::state_ptr);
   virtual Action::state_ptr performRedo(Action::state_ptr);
Index: src/Actions/AnalysisAction/PointCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,138 @@
+/*
+ * PointCorrelationAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/AnalysisAction/PointCorrelationAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "analysis_correlation.hpp"
+#include "boundary.hpp"
+#include "linkedcell.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+const char AnalysisPointCorrelationAction::NAME[] = "point-correlation";
+
+AnalysisPointCorrelationAction::AnalysisPointCorrelationAction() :
+  Action(NAME)
+{}
+
+AnalysisPointCorrelationAction::~AnalysisPointCorrelationAction()
+{}
+
+void AnalysisPointCorrelation(std::vector< element *> &elements, Vector &position, double BinStart, double BinWidth, double BinEnd, string &outputname, string &binoutputname, bool periodic) {
+  ValueStorage::getInstance().setCurrentValue("elements", elements);
+  ValueStorage::getInstance().setCurrentValue("position", position);
+  ValueStorage::getInstance().setCurrentValue("bin-start", BinStart);
+  ValueStorage::getInstance().setCurrentValue("bin-width", BinWidth);
+  ValueStorage::getInstance().setCurrentValue("bin-end", BinEnd);
+  ValueStorage::getInstance().setCurrentValue("output-file", outputname);
+  ValueStorage::getInstance().setCurrentValue("bin-output-file", binoutputname);
+  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
+  ActionRegistry::getInstance().getActionByName(AnalysisPointCorrelationAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* AnalysisPointCorrelationAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
+  dialog->queryElements("elements", ValueStorage::getInstance().getDescription("elements"));
+  dialog->queryDouble("bin-start", ValueStorage::getInstance().getDescription("bin-start"));
+  dialog->queryDouble("bin-width", ValueStorage::getInstance().getDescription("bin-width"));
+  dialog->queryDouble("bin-end", ValueStorage::getInstance().getDescription("bin-end"));
+  dialog->queryString("output-file", ValueStorage::getInstance().getDescription("output-file"));
+  dialog->queryString("bin-output-file", ValueStorage::getInstance().getDescription("bin-output-file"));
+  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
+
+  return dialog;
+}
+
+Action::state_ptr AnalysisPointCorrelationAction::performCall() {
+  int ranges[3] = {1, 1, 1};
+  double BinEnd = 0.;
+  double BinStart = 0.;
+  double BinWidth = 0.;
+  string outputname;
+  string binoutputname;
+  bool periodic;
+  ofstream output;
+  ofstream binoutput;
+  std::vector<const element *> elements;
+  string type;
+  Vector Point;
+  BinPairMap *binmap = NULL;
+
+  // obtain information
+  ValueStorage::getInstance().queryCurrentValue("position", Point);
+  ValueStorage::getInstance().queryCurrentValue("elements", elements);
+  ValueStorage::getInstance().queryCurrentValue("bin-start", BinStart);
+  ValueStorage::getInstance().queryCurrentValue("bin-width", BinWidth);
+  ValueStorage::getInstance().queryCurrentValue("bin-end", BinEnd);
+  ValueStorage::getInstance().queryCurrentValue("output-file", outputname);
+  ValueStorage::getInstance().queryCurrentValue("bin-output-file", binoutputname);
+  ValueStorage::getInstance().queryCurrentValue("periodic", periodic);
+
+  // execute action
+  output.open(outputname.c_str());
+  binoutput.open(binoutputname.c_str());
+  cout << "Point to correlate to is  " << Point << endl;
+  CorrelationToPointMap *correlationmap = NULL;
+  for(std::vector<const element *>::iterator iter = elements.begin(); iter != elements.end(); ++iter)
+    cout << "element is " << (*iter)->getSymbol() << endl;
+  std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
+  if (periodic)
+    correlationmap  = PeriodicCorrelationToPoint(molecules, elements, &Point, ranges);
+  else
+    correlationmap = CorrelationToPoint(molecules, elements, &Point);
+  OutputCorrelationToPoint(&output, correlationmap);
+  binmap = BinData( correlationmap, BinWidth, BinStart, BinEnd );
+  OutputCorrelation ( &binoutput, binmap );
+  delete(binmap);
+  delete(correlationmap);
+  output.close();
+  binoutput.close();
+  return Action::success;
+}
+
+Action::state_ptr AnalysisPointCorrelationAction::performUndo(Action::state_ptr _state) {
+  return Action::success;
+}
+
+Action::state_ptr AnalysisPointCorrelationAction::performRedo(Action::state_ptr _state){
+  return Action::success;
+}
+
+bool AnalysisPointCorrelationAction::canUndo() {
+  return true;
+}
+
+bool AnalysisPointCorrelationAction::shouldUndo() {
+  return true;
+}
+
+const string AnalysisPointCorrelationAction::getName() {
+  return NAME;
+}
Index: src/Actions/AnalysisAction/PointCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/AnalysisAction/PointCorrelationAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,46 @@
+/*
+ * PointCorrelationAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef POINTCORRELATIONACTION_HPP_
+#define POINTCORRELATIONACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Actions/Action.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include <vector>
+#include <string>
+
+class element;
+
+void AnalysisPointCorrelation(std::vector< element *> &elements, Vector &position, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
+
+class AnalysisPointCorrelationAction : public Action {
+  friend void AnalysisPointCorrelation(std::vector< element *> &elements, Vector &position, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
+
+public:
+  AnalysisPointCorrelationAction();
+  virtual ~AnalysisPointCorrelationAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog*);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* POINTCORRELATIONACTION_HPP_ */
